<?php  
// Enable error reporting for debugging  
ini_set('display_errors', 1);  
ini_set('display_startup_errors', 1);  
error_reporting(E_ALL);  
  
// TMDb API Key  
$tmdbApiKey = '2bca77a6dcb0c892cd1d4b677768fa88';  
  
// Database connection  
$host = 'localhost';  
$dbname = 'web_api_db';  
$username = 'web_api_user';  
$password = 'BHBNCL8fa5hcWs6D';  
  
try {  
   $conn = new PDO("mysql:host=$host;dbname=$dbname", $username, $password);  
   $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);  
} catch (PDOException $e) {  
   die("Database connection failed: " . $e->getMessage());  
}  
  
// Function to insert Network if not already present  
function insertNetworkIfNotExists($conn, $networkName, $logoUrl = 'https://example.com/logo.png') {  
   $stmt = $conn->prepare("SELECT id FROM networks WHERE name = :name LIMIT 1");  
   $stmt->execute([':name' => $networkName]);  
   $network = $stmt->fetch(PDO::FETCH_ASSOC);  
  
   if (!$network) {  
      // Insert Network into the networks table  
      $stmt = $conn->prepare("INSERT INTO networks (name, category, logo) VALUES (:name, :category, :logo)");  
      $stmt->execute([ ':name' => $networkName, ':category' => 'Other', ':logo' => $logoUrl ]);  
   }  
}  
  
// Function to find network based on production companies  
function getNetworkFromProductionCompanies($productionCompanies, $conn) {  
   foreach ($productionCompanies as $company) {  
      $companyName = strtolower($company['name']); // Convert to lowercase for case-insensitive comparison  
  
      // Query the database for a matching network  
      $stmt = $conn->prepare("SELECT name FROM networks WHERE LOWER(:companyName) LIKE LOWER(CONCAT('%', name, '%'))");  
      $stmt->execute([':companyName' => $companyName]);  
      $network = $stmt->fetch(PDO::FETCH_ASSOC);  
  
      if ($network) {  
        return $network['name']; // Return the matching network name from the database  
      } else {  
        // Insert the new company into the networks table dynamically  
        insertNetworkIfNotExists($conn, $company['name']);  
      }  
   }  
  
   return 'Other'; // Default category if no match is found  
}  
  
// Fetch YouTube trailer  
function fetchYouTubeTrailer($tmdbId, $apiKey) {  
   $url = "https://api.themoviedb.org/3/movie/$tmdbId/videos?api_key=$apiKey";  
   $data = @file_get_contents($url);  
  
   if ($data === false) {  
      return ''; // Handle API failure gracefully  
   }  
  
   $videos = json_decode($data, true);  
  
   if (!empty($videos['results'])) {  
      foreach ($videos['results'] as $video) {  
        if ($video['site'] === 'YouTube' && $video['type'] === 'Trailer') {  
           return 'https://www.youtube.com/watch?v=' . $video['key'];  
        }  
      }  
   }  
   return ''; // No valid trailer found  
}  
  
// Fetch IMDb rating, logo, and languages  
function fetchImdbRatingLogoAndLanguages($tmdbId, $apiKey) {  
   $url = "https://api.themoviedb.org/3/movie/$tmdbId?api_key=$apiKey";  
   $data = @file_get_contents($url);  
  
   if ($data === false) {  
      return [null, null, '']; // Handle API failure gracefully  
   }  
  
   $movieData = json_decode($data, true);  
  
   if (!empty($movieData)) {  
      // IMDb rating  
      $imdbRating = $movieData['vote_average']; // TMDb uses 'vote_average' as IMDb rating  
  
      // Fetch logo separately from the images endpoint  
      $logo = '';  
      $logoUrl = "https://api.themoviedb.org/3/movie/$tmdbId/images?api_key=$apiKey";  
      $imageData = @file_get_contents($logoUrl);  
  
      if ($imageData !== false) {  
        $images = json_decode($imageData, true);  
        if (!empty($images['logos'])) {  
           foreach ($images['logos'] as $img) {  
              if ($img['iso_639_1'] === 'en') { // Filter for English logo  
                $logo = 'https://image.tmdb.org/t/p/w500' . $img['file_path'];  
                break;  
              }  
           }  
        }  
      }  
  
      // Languages  
      $languages = implode(', ', array_map(function ($lang) {  
        return $lang['english_name'];  
      }, $movieData['spoken_languages']));  
  
      return [$imdbRating, $logo, $languages];  
   }  
  
   return [null, null, '']; // No data found  
}  
  
// Function to insert play links into the movie_play_links table  
function insertPlayLinks($tmdbId, $conn) {  
    $introStart = 0; 
    $introEnd = 0;
    $end_credits_marker = 0;
    $url = "https://vidsrc.icu/embed/movie/$tmdbId"; 
    
     $stmt = $conn->prepare("SELECT id FROM movies WHERE TMDB_ID = :tmdb_id LIMIT 1");
    $stmt->execute([':tmdb_id' => $tmdbId]);
    $movie = $stmt->fetch(PDO::FETCH_ASSOC);

    if (!$movie) {
        // Movie not found in the database, so return without inserting play links
        return;
    }
    $movieId = $movie['id'];
    $stmt = $conn->prepare("INSERT INTO movie_play_links 
        (name, size, quality, link_order, movie_id, url, type, status, skip_available, link_type, drm_uuid, drm_license_uri, intro_start, intro_end,end_credits_marker) 
        VALUES (:name, :size, :quality, :link_order, :movie_id, :url, :type, :status, :skip_available, :link_type, :drm_uuid, :drm_license_uri, :intro_start, :intro_end,:end_credits_marker)");  
    
    $stmt->execute([  
        ':name' => 'VidSrc',  
        ':size' => '',  
        ':quality' => '',  
        ':link_order' => 1,  
        ':movie_id' => $movieId, 
        ':url' => $url,  
        ':type' => 'vidsrc',  
        ':status' => 1,  
        ':skip_available' => 0,  
        ':link_type' => 0,  
        ':drm_uuid' => null,  
        ':drm_license_uri' => null,  
        ':intro_start' => $introStart,  // Using placeholder
        ':intro_end' => $introEnd,  
        ":end_credits_marker"=> $end_credits_marker,  
    ]);  
}

// Processing form submission  
$message = "";  
$success = false;  
if ($_SERVER['REQUEST_METHOD'] == 'POST' && !empty($_POST['tmdb_ids'])) {  
   $tmdbIds = explode(',', $_POST['tmdb_ids']);  
  
   foreach ($tmdbIds as $tmdbId) {  
      $tmdbId = trim($tmdbId);  
  
      // Fetch movie data from TMDb  
      $tmdbUrl = "https://api.themoviedb.org/3/movie/$tmdbId?api_key=$tmdbApiKey&language=en-US";  
      $tmdbData = @file_get_contents($tmdbUrl);  
      if ($tmdbData === false) {  
        $message .= "Error fetching data for TMDb ID $tmdbId.<br>";  
        continue;  
      }  
      $movieData = json_decode($tmdbData, true);  
  
      if (!empty($movieData)) {  
        $name = $movieData['title'];  
        $description = $movieData['overview'];  
        $genres = implode(', ', array_map(function ($genre) {  
           return $genre['name'];  
        }, $movieData['genres']));  
        $release_date = $movieData['release_date'];  
        $runtime = $movieData['runtime'];  
        $poster = 'https://image.tmdb.org/t/p/w500' . $movieData['poster_path'];  
        $banner = 'https://image.tmdb.org/t/p/w500' . $movieData['backdrop_path'];  
        $youtube_trailer = fetchYouTubeTrailer($tmdbId, $tmdbApiKey);  
        list($imdbRating, $logo, $languages) = fetchImdbRatingLogoAndLanguages($tmdbId, $tmdbApiKey);  
  
        // Determine the network dynamically based on production companies  
        $network = getNetworkFromProductionCompanies($movieData['production_companies'], $conn);  
  
        // Insert the corresponding network (if not already present)  
        insertNetworkIfNotExists($conn, $network);  
  
        try {  
           // Insert movie data into the database  
           $stmt = $conn->prepare("INSERT INTO movies (TMDB_ID, name, description, genres, release_date, runtime, IMDB_Rating, languages, poster, banner, logo, youtube_trailer, downloadable, type, status, content_type) VALUES (:tmdb_id, :name, :description, :genres, :release_date, :runtime, :imdb_rating, :languages, :poster, :banner, :logo, :youtube_trailer, :downloadable, :type, :status, :content_type)");  
           $stmt->execute([  
              ':tmdb_id' => $tmdbId,  
              ':name' => $name,  
              ':description' => $description,  
              ':genres' => $genres,  
              ':release_date' => $release_date,  
              ':runtime' => $runtime,  
              ':imdb_rating' => $imdbRating,  
              ':languages' => $languages,  
              ':poster' => $poster,  
              ':banner' => $banner,  
              ':logo' => $logo,  
              ':youtube_trailer' => $youtube_trailer,  
              ':downloadable' => 0, // Set based on your requirements  
              ':type' => '0', // Could be 'movie' or 'series'  
              ':status' => '1',  
              ':content_type' => '1'  
           ]);  
  
           // Insert play links into the movie_play_links table  
           insertPlayLinks($tmdbId, $conn);  
  
           $success = true;  
           $message .= "Successfully added movie '$name'.<br>";  
        } catch (Exception $e) {  
           $message .= "Error adding movie '$name': " . $e->getMessage() . "<br>";  
        }  
      }  
   }  
}  
?>  
<!DOCTYPE html>  
<html lang="en">  
<head>  
   <meta charset="UTF-8">  
   <meta name="viewport" content="width=device-width, initial-scale=1.0">  
   <title>TMDb Movie Data</title>  
   <link href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">  
</head>  
<body>  
   <div class="container mt-5">  
      <h1 class="text-center">TMDb Movie Data Insertion</h1>  
      <form method="POST" class="mt-4">  
        <div class="form-group">  
           <label for="tmdb_ids">Enter TMDb IDs (comma separated):</label>  
           <input type="text" id="tmdb_ids" name="tmdb_ids" class="form-control" required>  
        </div>  
        <button type="submit" class="btn btn-primary">Submit</button>  
      </form>  
  
      <?php if ($message): ?>  
        <div class="alert <?= $success ? 'alert-success' : 'alert-danger' ?> mt-4">  
           <?= $message ?>  
        </div>  
      <?php endif; ?>  
   </div>  
  
   <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>  
   <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.5.4/dist/umd/popper.min.js"></script>  
   <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>  
</body>  
</html>
