<?php
header('Access-Control-Allow-Origin: https://watchflix.threeminutesfix.in'); // Change to '*' to allow all domains
header('Access-Control-Allow-Methods: GET, POST, OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Authorization');
header('Content-Type: application/json');
// Check if all required parameters are provided
if (isset($_GET['api_key']) && isset($_GET['id']) && isset($_GET['season']) && isset($_GET['language']) && isset($_GET['image_storage_provider'])) {
    
    // Get parameters from the URL
    $apiKey = $_GET['api_key'];
    $tmdbId = $_GET['id'];
    $seasonNo = $_GET['season'];
    $language = $_GET['language'];
    $imageStorageProvider = $_GET['image_storage_provider'];

    // TMDB API URL for fetching season episodes
    $url = "https://api.themoviedb.org/3/tv/{$tmdbId}/season/{$seasonNo}?api_key={$apiKey}&language={$language}";

    // Initialize cURL session to make the API request
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_HEADER, false);

    // Execute the cURL request
    $response = curl_exec($ch);
    curl_close($ch);

    // Check if response was successful
    if ($response) {
        // Decode the JSON response to make it human-readable
        $data = json_decode($response, true);

        // Send JSON response
        header('Content-Type: application/json');
        echo json_encode($data);
    } else {
        // Handle API errors
        echo json_encode(['error' => 'Failed to fetch data from TMDB.']);
    }
} else {
    // If required parameters are missing
    echo json_encode(['error' => 'Missing required parameters.']);
}
?>
