<?php

header('Access-Control-Allow-Origin: https://api.threeminutesfix.in'); // Change to '*' to allow all domains
header('Access-Control-Allow-Methods: GET, POST, OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Authorization');
header('Content-Type: application/json');

// Assuming you already have the TMDB API key and the IMDB ID
$tmdbApiKey = "292e55fd6e9f6463b651315173e0d364"; // Replace with your actual TMDB API key
$imdbId = $_GET['id']; // Assuming the IMDB ID is passed via the URL

// URL for fetching movie videos
$videoApiUrl = "https://api.themoviedb.org/3/movie/{$imdbId}/videos?api_key={$tmdbApiKey}&language=en-US";

// Fetch video data from TMDB API
$response = file_get_contents($videoApiUrl);
$videoData = json_decode($response, true); // Decode JSON response into an associative array

// Initialize an array to store trailers
$trailers = [];

// Initialize counter for trailer naming
$trailerCounter = 1;

if (isset($videoData['results'])) {
    foreach ($videoData['results'] as $video) {
        // Check if the site is YouTube and the type is Trailer
        if ($video['site'] === "YouTube" && $video['type'] === "Trailer") {
            // Store the trailer URL with a key based on the counter
            $trailers["trailer_" . $trailerCounter] = "https://www.youtube.com/watch?v=" . $video['key'];

            // Increment the trailer counter
            $trailerCounter++;

            // Limit to 3 trailers as per your requirement
            if ($trailerCounter > 3) {
                break; // Exit loop after 3 trailers
            }
        }
    }
}

// Return the trailers as JSON response
header('Content-Type: application/json');
echo json_encode($trailers);
?>
