<?php

header('Access-Control-Allow-Origin: https://watchflix.threeminutesfix.in'); // Change to '*' to allow all domains
header('Access-Control-Allow-Methods: GET, POST, OPTIONS');
header('Access-Control-Allow-Headers: Content-Type, Authorization');
header('Content-Type: application/json');

// Your TMDB API key
$tmdbApiKey = "292e55fd6e9f6463b651315173e0d364"; // Replace with your actual TMDB API key
$imdbId = $_GET['id']; // Assuming the IMDb ID is passed via the URL

// Function to fetch trailers for a specific language
function fetchTrailers($imdbId, $language) {
    global $tmdbApiKey;
    $videoApiUrl = "https://api.themoviedb.org/3/movie/{$imdbId}/videos?api_key={$tmdbApiKey}&language={$language}";

    // Fetch video data from TMDB API
    $response = file_get_contents($videoApiUrl);
    return json_decode($response, true); // Decode JSON response into an associative array
}

// Initialize an array to store trailers
$trailers = [];

// Fetch trailers in English
$videoDataEN = fetchTrailers($imdbId, 'en-US');
if (isset($videoDataEN['results'])) {
    foreach ($videoDataEN['results'] as $video) {
        if ($video['site'] === "YouTube" && $video['type'] === "Trailer") {
            $trailers[] = [
                "name" => $video['name'],
                "url" => "https://www.youtube.com/watch?v=" . $video['key']
            ];
        }
    }
}

// Fetch trailers in Tamil
$videoDataTA = fetchTrailers($imdbId, 'ta-IN');
if (isset($videoDataTA['results'])) {
    foreach ($videoDataTA['results'] as $video) {
        if ($video['site'] === "YouTube" && $video['type'] === "Trailer") {
            $trailers[] = [
                "name" => $video['name'],
                "url" => "https://www.youtube.com/watch?v=" . $video['key']
            ];
        }
    }
}

// Return the trailers as JSON response
header('Content-Type: application/json');
echo json_encode($trailers);
?>
